/*#################################################################################################
	Name	: USI TWI Slave driver - I2C/TWI-EEPROM
	Version	: 1.2  - stabil running
	autor	: Martin Junghans	jtronics@gmx.de
	page	: www.jtronics.de
	License	: GNU General Public License 

	Created from Atmel source files for Application Note AVR312: Using the USI Modulea 
	as an I2C slave like a I2C-EEPROM.
//################################################################################################*/


#include 	<stdlib.h>
#include 	<avr/io.h>
#include 	<avr/interrupt.h>
#include 	<avr/pgmspace.h>

//###################### USI-TWI-I2C
#include 	"usiTwiSlave.h"     		
#define 	SLAVE_ADR_ATTINY_1       0b00110100  	// i2c slave address

#ifndef 	F_CPU
#define 	F_CPU 8000000UL
#endif
//###################### Macros
#define uniq(LOW,HEIGHT)	((HEIGHT << 8)|LOW)			// 2x 8Bit 	--> 16Bit
#define LOW_BYTE(x)        	(x & 0xff)					// 16Bit 	--> 8Bit
#define HIGH_BYTE(x)       	((x >> 8) & 0xff)			// 16Bit 	--> 8Bit

#define sbi(ADDRESS,BIT) 	((ADDRESS) |= (1<<(BIT)))	// set Bit
#define cbi(ADDRESS,BIT) 	((ADDRESS) &= ~(1<<(BIT)))	// clear Bit
#define	toggle(ADDRESS,BIT)	((ADDRESS) ^= (1<<BIT))		// Bit umschalten

#define	bis(ADDRESS,BIT)	(ADDRESS & (1<<BIT))		// bit is set?
#define	bic(ADDRESS,BIT)	(!(ADDRESS & (1<<BIT)))		// bit is clear?

//###################### Variablen
	uint16_t 	Variable=2345;				//Zhler
	uint16_t	buffer;
	uint16_t	low, hight;


//######################################################################################################################## Hauptprogramm
int main(void)
{	 
	cli();
	DDRD	=0b00000000;
	PORTD	=0b00000000;
	
	usiTwiSlaveInit(SLAVE_ADR_ATTINY_1);	//TWI Slave Init
	sei();

while(1)
    {
	//############################ write Data in txbuffer
	
	// 8Bit variable
	txbuffer[2]=3;	
	txbuffer[3]=4;		
	txbuffer[4]=5;	
	txbuffer[5]=6;	
	
	// 16Bit Variable --> 2x 8Bit Variable
	buffer		= Variable;
	txbuffer[0]	= LOW_BYTE(buffer);			//16bit --> 8bit
	txbuffer[1]	= HIGH_BYTE(buffer);		//16bit --> 8bit
	
	
	
	//############################ read Data form rxbuffer

	// 8Bit variable
	Variable	= rxbuffer[2];
	
	// 2x 8Bit Variable -->16Bit Variable
	low			= rxbuffer[0];
	hight		= rxbuffer[1];
	Variable	= uniq(low,hight);			// 2x 8Bit  --> 16Bit
	
	
	//############################
	} //end.while
} //end.main



